const { isFrameworkPackage } = require('../../helpers/manager');

const path = require('path');

function collectStatics($package) {
    if (Is.empty($package.static)) return;

    if (! isFrameworkPackage($package.name)) return;

    const map = files => {
        return files.map(file => {
            return NODE_MODULES_DIR + '/' + $package.name + '/' + file;
        });
    };

    for (let type in $package.static) {
        if (type == 'js') {
            resources['jsVendor'] = Object.merge(resources['jsVendor'], map($package.static.js));
        } else if (type == 'css') {
            for (let direction of $package.static.css) {
                if (! ['common', CURRENT_DIRECTION].includes(direction)) continue;
                resources['cssVendor'] = Object.merge(resources['cssVendor'], map($package.static.css[direction]));
            }
        }
    }
}

module.exports = collectStatics;