const { fs } = require('./../../bootstrap/modules');

// CURRENT_DIRECTION from sass compiler 

function saveVendors($package) {
    let $vendors = {
        js: [],
        css: {},
    };

    // first we need to filter css files
    // so we will append the rtl/ltr files to the common css files
    $vendors['js'] = Object.get($package['vendor'], 'js');

    let $vendorsCss = Object.get($package['vendor'], 'css');

    $vendors['css'] = Object.get($vendorsCss, 'common');

    if (!Is.empty($vendorsCss[CURRENT_DIRECTION])) {
        $vendors['css'] = Object.merge($vendors['css'], vendors['css'][CURRENT_DIRECTION]);
    }

    for (let $vendorType in $vendors) {
        let $vendorsList = $vendors[$vendorType];

        for (let $vendor of $vendorsList) {
            let resourceType = $vendorType == 'js' ? 'jsVendor': 'cssVendor';

            let vendorPath = NODE_MODULES_DIR + '/' + $vendor;
            
            if (!fs.exists(vendorPath)) {
                return error(new Error('Not Found Vendor: ' + $vendor));
                throw new Error('Not Found Vendor: ' + $vendor);
            }

            if (!resources[resourceType].includes($vendor)) {
                resources[resourceType].push($vendor);
            }
        }
    }
}

module.exports = saveVendors;