require('./global-helpers');
const crypto = require('crypto');

function isFrameworkPackage(packageName) {
    return packageName.startsWith(process.env.CLI_NAME + '-') || packageName.startsWith(`@${process.env.CLI_NAME}/`);
}

function sha1(string) {
    const shasum = crypto.createHash('sha1');
    shasum.update(string);
    return shasum.digest('hex');
}

function getAppName(command) {
    // return command.options.app || 'common'; // we may change common to APP_NAME
    return command.options.app || APP_NAME; // we may change common to APP_NAME
}

module.exports = {
    isFrameworkPackage,
    sha1,
    getAppName,
}