const { fs } = require('@flk/fs');

const path = require('path');

class AssetsWatcher {
    /**
     * Constructor
     */
    constructor(eyeOrb) {
        this.eyeOrb = eyeOrb;
        this.startWatching();
    }

    /**
     * Start watching
     */
    startWatching() {
        this.eyeOrb.watch([
            `${APP_DIR}/assets/**`,
            `${COMMON_APP_DIR}/assets/**`
        ]).on('add', filePath => {
            let assetRelativePath;

            filePath = filePath.replace(/\\/g, '/');

            if (filePath.startsWith(APP_DIR)) {
                assetRelativePath = filePath.replace(APP_DIR + '/assets/', '');
            } else if (filePath.startsWith(COMMON_APP_DIR)) {
                assetRelativePath = filePath.replace(COMMON_APP_DIR + '/assets/', '');
            }

            let fileDirectory = path.dirname(STATIC_DIR + '/' + assetRelativePath);

            if (! fs.isDirectory(fileDirectory)) {
                fs.makeDirectory(fileDirectory);
            }

            fs.copy(filePath, STATIC_DIR + '/' + assetRelativePath);

            reloadApp();
        });
    }
}

module.exports = AssetsWatcher;